/**
 * Klasse fr eine Schlange nach Zentralabitur.
 * @author Daniel Garmann
 * @version 18.08.2008
 */
public class Queue {
  private QElement pHead;
  private QElement pTail;

  /**
   * Konstruktor create
   * Nachher: Eine leere Schlange ist erzeugt.
   */
  public Queue() {
    pHead = null;
    pTail = null;
  }

  /**
   * Auftrag dequeue
   * Vorher:  Die Schlange ist nicht leer.
   * Nachher: Das vorderste Element ist aus der Schlange entfernt.
   */
  public void dequeue() {
    if (!this.isEmpty()) {
      pHead = pHead.next();
    }
  }

  /**
   * Auftrag enqueue (pObject:Object)
   * Vorher:  Die Schlange ist erzeugt.
   * Nachher: pObject ist als letztes Element in der Schlange abgelegt.
   */
  public void enqueue(Object pObject) {
    QElement newElement = new QElement(pObject, null);

    if (this.isEmpty()) {
      pHead = newElement;
      pTail = newElement;
    } else {
      pTail.setNext(newElement);
      pTail = newElement;
    }
  }

  /**
   * Anfrage front: Object
   * Vorher:  Die Schlange ist nicht leer.
   * Nachher: Die Anfrage liefert das vorderste Element der Schlange.
   *          Die Schlange istunverndert.
   */
  public Object front() {
    if (pHead != null)
      return pHead.content();
    else
      return null;
  }

  /**
   * Anfrage isEmpty: boolean
   * Nachher: Die Anfrage liefert den Wert true, wenn die Schlange keine Elemente
   *          enthlt, sonst liefert sie den Wert false.
   */
  public boolean isEmpty() {
    return pHead == null;
  }

  /**
   * Destruktor destroy
   * Nachher: Die Schlange existiert nicht mehr.
   */
  public void free() {
    while (!this.isEmpty())
      this.dequeue();
  }
}
