/**
 * Klasse fr einen Stapel nach Zentralabitur.
 * @author Daniel Garmann
 * @version 18.08.2008
 */
public class Stack {
  private SElement pHead;

  /**
   * Konstruktor create
   * Nachher: Ein leerer Stapel ist erzeugt.
   */
  public Stack() {
    pHead = null;
  }

  /**
   *  Anfrage isEmpty: boolean
   *  Nachher: Die Anfrage liefert den Wert true, wenn der Stapel keine Elemente
   *           enthlt, sonst liefert sie den Wert false.
   */
  public boolean isEmpty() {
    return pHead == null;
  }

  /**
   * Anfrage top: Object
   * Vorher:  Der Stapel ist nicht leer.
   * Nachher: Die Anfrage liefert das oberste Stapelelement. Der Stapel ist
   *          unverndert.
   */
  public Object top() {
    if (!this.isEmpty()) {
      return pHead.content();
    } else {
      return null;
    }
  }

  /**
   * Auftrag pop
   * Vorher:  Der Stapel ist nicht leer.
   * Nachher: Das zuletzt eingefgte Element ist von dem Stapel entfernt.
   */
  public void pop() {
    if (!isEmpty()) {
      pHead = pHead.next();
    }
  }

  /**
   * Auftrag push (pObject: Object)
   * Vorher:  Der Stapel ist erzeugt.
   * Nachher: pObject liegt oben auf dem Stapel.
   */
  public void push(Object pObject) {
    if (pObject != null) {
      SElement newElement = new SElement(pObject, pHead);
      pHead = newElement;
    }
  }
}
