/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 04.03.2010
  * @author Daniel Garmann
  */

public class Termauswerter {

  // Anfang Attribute
  private static Queue zerlegung;
  private static Stack operandenStack;
  private static Stack operatorenStack;
  private static int hilfsvariablenZaehler = 0;
  // Ende Attribute

  // Anfang Methoden
  public Termauswerter() {
  }
  
  private static String naechstesZeichen(String term) {
    if (term.length() > 0) {
      if (istOperator(term)) {
        char c = term.charAt(0);
        term = term.substring(1);
        return ""+c;
      }
      String result = "";
      while (istOperand(term)) {
        result = result + term.charAt(0);
        term = term.substring(1);
      }
      if (result.length() > 0) {
        return result;
      }
      return "";
    } else {
      return "";
    }
  }

  private static int prioritaet(String operator) {
    char c = operator.charAt(0);
    if (c == '=') return 0;
    if (c == '(') return 1;
    if (c == '+' || c == '-') return 2;
    if (c == '*' || c == '/') return 3;
    if (c == '^') return 4;
    return -1;
  }

  private static String loescheNaechstesZeichen(String term) {
    String c = naechstesZeichen(term);
    return term.substring(c.length());
  }

  private static boolean istOperator(String zeichen) {
    if (zeichen.length() > 0) {
      char c = zeichen.charAt(0);
      if (c == '(' || c == ')' || c == '+' || c == '-' || c == '*' || c == '/' || c == '^' || c == '=') {
        return true;
      } else {
        return false;
      }
    } else {
      return false;
    }
  }
  
  private static boolean istOperand(String zeichen) {
    if (zeichen.length() > 0) {
      char c = zeichen.charAt(0);
      if (c >= '0' && c <= '9' || c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z') {
        return true;
      } else {
        return false;
      }
    } else {
      return false;
    }
  }
  
  private static void rechenschrittDurchfuehren() {
    String operand2 = (String)operandenStack.top();
    operandenStack.pop();
    String operand1 = (String)operandenStack.top();
    operandenStack.pop();
    String operator = (String)operatorenStack.top();
    operatorenStack.pop();
    if (operator.equals("=")) {
      zerlegung.enqueue(operand1 + " " + operator + " " + operand2);
    } else {
      hilfsvariablenZaehler++;
      String hilfsvariable = "hilf"+hilfsvariablenZaehler;
      zerlegung.enqueue(hilfsvariable + " = " + operand1 + " " + operator + " " + operand2);
      operandenStack.push(hilfsvariable);
    }

  }
  
  public static Queue zerlege(String term) {
    zerlegung = new Queue();
    operandenStack = new Stack();
    operatorenStack = new Stack();
    hilfsvariablenZaehler = 0;
    while (term.length() > 0) {
      String zeichen = naechstesZeichen(term);
      term = loescheNaechstesZeichen(term);
      if (zeichen.charAt(0)=='(') {
        operatorenStack.push(zeichen);
      } else if (zeichen.charAt(0)==')') {
        while ( !((String)operatorenStack.top()).equals("(") ) {
          rechenschrittDurchfuehren();
        }
        operatorenStack.pop();
      } else if (istOperand(zeichen)) {
        operandenStack.push(zeichen);
      } else if (istOperator(zeichen)) {
        while (!operatorenStack.isEmpty() && (prioritaet(zeichen) <= prioritaet((String)operatorenStack.top()))) {
          rechenschrittDurchfuehren();
        }
        operatorenStack.push(zeichen);
      }
    }
    while (!operatorenStack.isEmpty()) {
      rechenschrittDurchfuehren();
    }
    return zerlegung;
  }

  
  // Ende Methoden
}
